diff --git a/include/odp/api/packet_flags.h b/include/odp/api/packet_flags.h
index df1486b..f9e8ae8 100644
--- a/include/odp/api/packet_flags.h
+++ b/include/odp/api/packet_flags.h
@@ -41,7 +41,8 @@ int odp_packet_has_error(odp_packet_t pkt);
  * Check for L2 header, e.g. ethernet
  *
  * @param pkt Packet handle
- * @return 1 if packet contains a valid & known L2 header, 0 otherwise
+ * @retval 1 if packet contains a valid & known L2 header
+ * @retval 0 if packet does not contain a valid & known L2 header
  */
 int odp_packet_has_l2(odp_packet_t pkt);
 
@@ -49,7 +50,8 @@ int odp_packet_has_l2(odp_packet_t pkt);
  * Check for L3 header, e.g. IPv4, IPv6
  *
  * @param pkt Packet handle
- * @return 1 if packet contains a valid & known L3 header, 0 otherwise
+ * @retval 1 if packet contains a valid & known L3 header
+ * @retval 0 if packet does not contain a valid & known L3 header
  */
 int odp_packet_has_l3(odp_packet_t pkt);
 
@@ -57,7 +59,8 @@ int odp_packet_has_l3(odp_packet_t pkt);
  * Check for L4 header, e.g. UDP, TCP, SCTP (also ICMP)
  *
  * @param pkt Packet handle
- * @return 1 if packet contains a valid & known L4 header, 0 otherwise
+ * @retval 1 if packet contains a valid & known L4 header
+ * @retval 0 if packet does not contain a valid & known L4 header
  */
 int odp_packet_has_l4(odp_packet_t pkt);
 
@@ -65,7 +68,8 @@ int odp_packet_has_l4(odp_packet_t pkt);
  * Check for Ethernet header
  *
  * @param pkt Packet handle
- * @return 1 if packet contains a valid eth header, 0 otherwise
+ * @retval 1 if packet contains a valid eth header
+ * @retval 0 if packet does not contain a valid & known eth header
  */
 int odp_packet_has_eth(odp_packet_t pkt);
 
@@ -73,7 +77,8 @@ int odp_packet_has_eth(odp_packet_t pkt);
  * Check for jumbo frame
  *
  * @param pkt Packet handle
- * @return 1 if packet contains jumbo frame, 0 otherwise
+ * @retval 1 if packet contains a jumbo frame
+ * @retval 0 if packet does not contain a jumbo frame
  */
 int odp_packet_has_jumbo(odp_packet_t pkt);
 
@@ -81,7 +86,8 @@ int odp_packet_has_jumbo(odp_packet_t pkt);
  * Check for VLAN
  *
  * @param pkt Packet handle
- * @return 1 if packet contains a VLAN header, 0 otherwise
+ * @retval 1 if packet contains a VLAN header
+ * @retval 0 if packet does not contain a VLAN header
  */
 int odp_packet_has_vlan(odp_packet_t pkt);
 
@@ -89,7 +95,8 @@ int odp_packet_has_vlan(odp_packet_t pkt);
  * Check for VLAN QinQ (stacked VLAN)
  *
  * @param pkt Packet handle
- * @return 1 if packet contains a VLAN QinQ header, 0 otherwise
+ * @retval 1 if packet contains a VLAN QinQ header
+ * @retval 0 if packet does not contain a VLAN QinQ header
  */
 int odp_packet_has_vlan_qinq(odp_packet_t pkt);
 
@@ -97,7 +104,8 @@ int odp_packet_has_vlan_qinq(odp_packet_t pkt);
  * Check for ARP
  *
  * @param pkt Packet handle
- * @return 1 if packet contains an ARP header, 0 otherwise
+ * @retval 1 if packet contains an ARP message
+ * @retval 0 if packet does not contain an ARP message
  */
 int odp_packet_has_arp(odp_packet_t pkt);
 
@@ -105,7 +113,8 @@ int odp_packet_has_arp(odp_packet_t pkt);
  * Check for IPv4
  *
  * @param pkt Packet handle
- * @return 1 if packet contains an IPv4 header, 0 otherwise
+ * @retval 1 if packet contains an IPv4 header
+ * @retval 0 if packet does not contain an IPv4 header
  */
 int odp_packet_has_ipv4(odp_packet_t pkt);
 
@@ -113,7 +122,8 @@ int odp_packet_has_ipv4(odp_packet_t pkt);
  * Check for IPv6
  *
  * @param pkt Packet handle
- * @return 1 if packet contains an IPv6 header, 0 otherwise
+ * @retval 1 if packet contains an IPv6 header
+ * @retval 0 if packet does not contain an IPv6 header
  */
 int odp_packet_has_ipv6(odp_packet_t pkt);
 
@@ -121,7 +131,8 @@ int odp_packet_has_ipv6(odp_packet_t pkt);
  * Check for IP fragment
  *
  * @param pkt Packet handle
- * @return 1 if packet is an IP fragment, 0 otherwise
+ * @retval 1 if packet is an IP fragment
+ * @retval 0 if packet is not an IP fragment
  */
 int odp_packet_has_ipfrag(odp_packet_t pkt);
 
@@ -129,7 +140,8 @@ int odp_packet_has_ipfrag(odp_packet_t pkt);
  * Check for IP options
  *
  * @param pkt Packet handle
- * @return 1 if packet contains IP options, 0 otherwise
+ * @retval 1 if packet contains IP options
+ * @retval 0 if packet does not contain IP options
  */
 int odp_packet_has_ipopt(odp_packet_t pkt);
 
@@ -137,7 +149,8 @@ int odp_packet_has_ipopt(odp_packet_t pkt);
  * Check for IPSec
  *
  * @param pkt Packet handle
- * @return 1 if packet requires IPSec processing, 0 otherwise
+ * @retval 1 if packet requires IPSec processing
+ * @retval 0 if packet does not require IPSec processing
  */
 int odp_packet_has_ipsec(odp_packet_t pkt);
 
@@ -145,7 +158,8 @@ int odp_packet_has_ipsec(odp_packet_t pkt);
  * Check for UDP
  *
  * @param pkt Packet handle
- * @return 1 if packet contains a UDP header, 0 otherwise
+ * @retval 1 if packet contains a UDP header
+ * @retval 0 if packet does not contain a UDP header
  */
 int odp_packet_has_udp(odp_packet_t pkt);
 
@@ -153,7 +167,8 @@ int odp_packet_has_udp(odp_packet_t pkt);
  * Check for TCP
  *
  * @param pkt Packet handle
- * @return 1 if packet contains a TCP header, 0 otherwise
+ * @retval 1 if packet contains a TCP header
+ * @retval 0 if packet does not contain a TCP header
  */
 int odp_packet_has_tcp(odp_packet_t pkt);
 
@@ -161,7 +176,8 @@ int odp_packet_has_tcp(odp_packet_t pkt);
  * Check for SCTP
  *
  * @param pkt Packet handle
- * @return 1 if packet contains an SCTP header, 0 otherwise
+ * @retval 1 if packet contains a SCTP header
+ * @retval 0 if packet does not contain a SCTP header
  */
 int odp_packet_has_sctp(odp_packet_t pkt);
 
@@ -169,7 +185,8 @@ int odp_packet_has_sctp(odp_packet_t pkt);
  * Check for ICMP
  *
  * @param pkt Packet handle
- * @return 1 if packet contains an ICMP header, 0 otherwise
+ * @retval 1 if packet contains an ICMP header
+ * @retval 0 if packet does not contain an ICMP header
  */
 int odp_packet_has_icmp(odp_packet_t pkt);
 