diff --git a/include/odp/api/align.h b/include/odp/api/align.h
index b97ee57..97cedc3 100644
--- a/include/odp/api/align.h
+++ b/include/odp/api/align.h
@@ -11,8 +11,8 @@
  * ODP alignments
  */
 
-#ifndef ODP_ALIGN_H_
-#define ODP_ALIGN_H_
+#ifndef ODP_API_ALIGN_H_
+#define ODP_API_ALIGN_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/atomic.h b/include/odp/api/atomic.h
index 9e759fb..ba5c354 100644
--- a/include/odp/api/atomic.h
+++ b/include/odp/api/atomic.h
@@ -11,8 +11,8 @@
  * ODP atomic operations
  */
 
-#ifndef ODP_ATOMIC_H_
-#define ODP_ATOMIC_H_
+#ifndef ODP_API_ATOMIC_H_
+#define ODP_API_ATOMIC_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/barrier.h b/include/odp/api/barrier.h
index 2066210..35f0981 100644
--- a/include/odp/api/barrier.h
+++ b/include/odp/api/barrier.h
@@ -11,8 +11,8 @@
  * ODP execution barriers
  */
 
-#ifndef ODP_BARRIER_H_
-#define ODP_BARRIER_H_
+#ifndef ODP_API_BARRIER_H_
+#define ODP_API_BARRIER_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/buffer.h b/include/odp/api/buffer.h
index 4bbac1e..9ad08ea 100644
--- a/include/odp/api/buffer.h
+++ b/include/odp/api/buffer.h
@@ -11,8 +11,8 @@
  * ODP buffer descriptor
  */
 
-#ifndef ODP_BUFFER_H_
-#define ODP_BUFFER_H_
+#ifndef ODP_API_BUFFER_H_
+#define ODP_API_BUFFER_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/byteorder.h b/include/odp/api/byteorder.h
index 3a36afc..a7b3647 100644
--- a/include/odp/api/byteorder.h
+++ b/include/odp/api/byteorder.h
@@ -11,8 +11,8 @@
  * ODP byteorder
  */
 
-#ifndef ODP_BYTEORDER_H_
-#define ODP_BYTEORDER_H_
+#ifndef ODP_API_BYTEORDER_H_
+#define ODP_API_BYTEORDER_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/classification.h b/include/odp/api/classification.h
index 5a61bd8..8758fb5 100644
--- a/include/odp/api/classification.h
+++ b/include/odp/api/classification.h
@@ -11,8 +11,8 @@
  * ODP classification descriptor
  */
 
-#ifndef ODP_CLASSIFY_H_
-#define ODP_CLASSIFY_H_
+#ifndef ODP_API_CLASSIFY_H_
+#define ODP_API_CLASSIFY_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/compiler.h b/include/odp/api/compiler.h
index 71a4431..5a24bfb 100644
--- a/include/odp/api/compiler.h
+++ b/include/odp/api/compiler.h
@@ -11,8 +11,8 @@
  * Compiler related
  */
 
-#ifndef ODP_COMPILER_H_
-#define ODP_COMPILER_H_
+#ifndef ODP_API_COMPILER_H_
+#define ODP_API_COMPILER_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/config.h b/include/odp/api/config.h
index 3529fca..bd69b98 100644
--- a/include/odp/api/config.h
+++ b/include/odp/api/config.h
@@ -11,8 +11,8 @@
  * ODP configuration
  */
 
-#ifndef ODP_CONFIG_H_
-#define ODP_CONFIG_H_
+#ifndef ODP_API_CONFIG_H_
+#define ODP_API_CONFIG_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/cpumask.h b/include/odp/api/cpumask.h
index a78d83c..831f745 100644
--- a/include/odp/api/cpumask.h
+++ b/include/odp/api/cpumask.h
@@ -11,8 +11,8 @@
  * ODP CPU masks and enumeration
  */
 
-#ifndef ODP_CPUMASK_H_
-#define ODP_CPUMASK_H_
+#ifndef ODP_API_CPUMASK_H_
+#define ODP_API_CPUMASK_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/crypto.h b/include/odp/api/crypto.h
index dbdc5b9..a71753c 100644
--- a/include/odp/api/crypto.h
+++ b/include/odp/api/crypto.h
@@ -11,8 +11,8 @@
  * ODP crypto
  */
 
-#ifndef ODP_CRYPTO_H_
-#define ODP_CRYPTO_H_
+#ifndef ODP_API_CRYPTO_H_
+#define ODP_API_CRYPTO_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/debug.h b/include/odp/api/debug.h
index 05f4e9e..5949680 100644
--- a/include/odp/api/debug.h
+++ b/include/odp/api/debug.h
@@ -9,8 +9,8 @@
  * ODP debug
  */
 
-#ifndef ODP_DEBUG_H_
-#define ODP_DEBUG_H_
+#ifndef ODP_API_DEBUG_H_
+#define ODP_API_DEBUG_H_
 
 
 #ifdef __cplusplus
diff --git a/include/odp/api/event.h b/include/odp/api/event.h
index b1cc916..63b476f 100644
--- a/include/odp/api/event.h
+++ b/include/odp/api/event.h
@@ -11,8 +11,8 @@
  * ODP event
  */
 
-#ifndef ODP_EVENT_H_
-#define ODP_EVENT_H_
+#ifndef ODP_API_EVENT_H_
+#define ODP_API_EVENT_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/hints.h b/include/odp/api/hints.h
index ebf83fc..7ec8c29 100644
--- a/include/odp/api/hints.h
+++ b/include/odp/api/hints.h
@@ -11,8 +11,8 @@
  * ODP compiler hints
  */
 
-#ifndef ODP_HINTS_H_
-#define ODP_HINTS_H_
+#ifndef ODP_API_HINTS_H_
+#define ODP_API_HINTS_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/init.h b/include/odp/api/init.h
index 7353d0b..b8fab78 100644
--- a/include/odp/api/init.h
+++ b/include/odp/api/init.h
@@ -19,8 +19,8 @@
  * - odp_term_local()
  */
 
-#ifndef ODP_INIT_H_
-#define ODP_INIT_H_
+#ifndef ODP_API_INIT_H_
+#define ODP_API_INIT_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/packet.h b/include/odp/api/packet.h
index 1abcbc3..a31c54d 100644
--- a/include/odp/api/packet.h
+++ b/include/odp/api/packet.h
@@ -11,8 +11,8 @@
  * ODP packet descriptor
  */
 
-#ifndef ODP_PACKET_H_
-#define ODP_PACKET_H_
+#ifndef ODP_API_PACKET_H_
+#define ODP_API_PACKET_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/packet_flags.h b/include/odp/api/packet_flags.h
index 308b0d8..b1e179e 100644
--- a/include/odp/api/packet_flags.h
+++ b/include/odp/api/packet_flags.h
@@ -11,8 +11,8 @@
  * ODP packet flags
  */
 
-#ifndef ODP_PACKET_FLAGS_H_
-#define ODP_PACKET_FLAGS_H_
+#ifndef ODP_API_PACKET_FLAGS_H_
+#define ODP_API_PACKET_FLAGS_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/packet_io.h b/include/odp/api/packet_io.h
index 3e4bac4..31f1c1e 100644
--- a/include/odp/api/packet_io.h
+++ b/include/odp/api/packet_io.h
@@ -11,8 +11,8 @@
  * ODP Packet IO
  */
 
-#ifndef ODP_PACKET_IO_H_
-#define ODP_PACKET_IO_H_
+#ifndef ODP_API_PACKET_IO_H_
+#define ODP_API_PACKET_IO_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/pool.h b/include/odp/api/pool.h
index f5dda10..b8c0f2e 100644
--- a/include/odp/api/pool.h
+++ b/include/odp/api/pool.h
@@ -11,8 +11,8 @@
  * ODP pool
  */
 
-#ifndef ODP_POOL_H_
-#define ODP_POOL_H_
+#ifndef ODP_API_POOL_H_
+#define ODP_API_POOL_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/queue.h b/include/odp/api/queue.h
index ed57ba4..9519edf 100644
--- a/include/odp/api/queue.h
+++ b/include/odp/api/queue.h
@@ -11,8 +11,8 @@
  * ODP queue
  */
 
-#ifndef ODP_QUEUE_H_
-#define ODP_QUEUE_H_
+#ifndef ODP_API_QUEUE_H_
+#define ODP_API_QUEUE_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/random.h b/include/odp/api/random.h
index 3bc1aeb..293043e 100644
--- a/include/odp/api/random.h
+++ b/include/odp/api/random.h
@@ -11,8 +11,8 @@
  * ODP random number API
  */
 
-#ifndef ODP_RANDOM_H_
-#define ODP_RANDOM_H_
+#ifndef ODP_API_RANDOM_H_
+#define ODP_API_RANDOM_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/rwlock.h b/include/odp/api/rwlock.h
index f9d418e..950b83a 100644
--- a/include/odp/api/rwlock.h
+++ b/include/odp/api/rwlock.h
@@ -4,8 +4,8 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
-#ifndef ODP_RWLOCK_H_
-#define ODP_RWLOCK_H_
+#ifndef ODP_API_RWLOCK_H_
+#define ODP_API_RWLOCK_H_
 
 /**
  * @file
diff --git a/include/odp/api/schedule.h b/include/odp/api/schedule.h
index 3019b84..8abec21 100644
--- a/include/odp/api/schedule.h
+++ b/include/odp/api/schedule.h
@@ -11,8 +11,8 @@
  * ODP schedule
  */
 
-#ifndef ODP_SCHEDULE_H_
-#define ODP_SCHEDULE_H_
+#ifndef ODP_API_SCHEDULE_H_
+#define ODP_API_SCHEDULE_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/shared_memory.h b/include/odp/api/shared_memory.h
index d4445f7..de40bcd 100644
--- a/include/odp/api/shared_memory.h
+++ b/include/odp/api/shared_memory.h
@@ -11,8 +11,8 @@
  * ODP shared memory
  */
 
-#ifndef ODP_SHARED_MEMORY_H_
-#define ODP_SHARED_MEMORY_H_
+#ifndef ODP_API_SHARED_MEMORY_H_
+#define ODP_API_SHARED_MEMORY_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/spinlock.h b/include/odp/api/spinlock.h
index 504e629..5cde123 100644
--- a/include/odp/api/spinlock.h
+++ b/include/odp/api/spinlock.h
@@ -11,8 +11,8 @@
  * ODP spinlock
  */
 
-#ifndef ODP_SPINLOCK_H_
-#define ODP_SPINLOCK_H_
+#ifndef ODP_API_SPINLOCK_H_
+#define ODP_API_SPINLOCK_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/std_types.h b/include/odp/api/std_types.h
index 00a3e48..7558c64 100644
--- a/include/odp/api/std_types.h
+++ b/include/odp/api/std_types.h
@@ -12,8 +12,8 @@
  *
  */
 
-#ifndef ODP_STD_TYPES_H_
-#define ODP_STD_TYPES_H_
+#ifndef ODP_API_STD_TYPES_H_
+#define ODP_API_STD_TYPES_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/sync.h b/include/odp/api/sync.h
index d9daada..b338a98 100644
--- a/include/odp/api/sync.h
+++ b/include/odp/api/sync.h
@@ -11,8 +11,8 @@
  * ODP synchronisation
  */
 
-#ifndef ODP_SYNC_H_
-#define ODP_SYNC_H_
+#ifndef ODP_API_SYNC_H_
+#define ODP_API_SYNC_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/system_info.h b/include/odp/api/system_info.h
index c14d654..4d7f0e7 100644
--- a/include/odp/api/system_info.h
+++ b/include/odp/api/system_info.h
@@ -11,8 +11,8 @@
  * ODP system information
  */
 
-#ifndef ODP_SYSTEM_INFO_H_
-#define ODP_SYSTEM_INFO_H_
+#ifndef ODP_API_SYSTEM_INFO_H_
+#define ODP_API_SYSTEM_INFO_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/thread.h b/include/odp/api/thread.h
index d6016cb..e5185f2 100644
--- a/include/odp/api/thread.h
+++ b/include/odp/api/thread.h
@@ -11,8 +11,8 @@
  * ODP thread API
  */
 
-#ifndef ODP_THREAD_H_
-#define ODP_THREAD_H_
+#ifndef ODP_API_THREAD_H_
+#define ODP_API_THREAD_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/ticketlock.h b/include/odp/api/ticketlock.h
index 2116e3e..e088e8b 100644
--- a/include/odp/api/ticketlock.h
+++ b/include/odp/api/ticketlock.h
@@ -11,8 +11,8 @@
  * ODP ticketlock
  */
 
-#ifndef ODP_TICKETLOCK_H_
-#define ODP_TICKETLOCK_H_
+#ifndef ODP_API_TICKETLOCK_H_
+#define ODP_API_TICKETLOCK_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/time.h b/include/odp/api/time.h
index aba841c..6b811d0 100644
--- a/include/odp/api/time.h
+++ b/include/odp/api/time.h
@@ -11,8 +11,8 @@
  * ODP time
  */
 
-#ifndef ODP_TIME_H_
-#define ODP_TIME_H_
+#ifndef ODP_API_TIME_H_
+#define ODP_API_TIME_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/timer.h b/include/odp/api/timer.h
index 64ccc4b..ff45795 100644
--- a/include/odp/api/timer.h
+++ b/include/odp/api/timer.h
@@ -11,8 +11,8 @@
  * ODP timer service
  */
 
-#ifndef ODP_TIMER_H_
-#define ODP_TIMER_H_
+#ifndef ODP_API_TIMER_H_
+#define ODP_API_TIMER_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/include/odp/api/version.h b/include/odp/api/version.h
index 0889d9c..8807ea8 100644
--- a/include/odp/api/version.h
+++ b/include/odp/api/version.h
@@ -11,8 +11,8 @@
  * ODP version
  */
 
-#ifndef ODP_VERSION_H_
-#define ODP_VERSION_H_
+#ifndef ODP_API_VERSION_H_
+#define ODP_API_VERSION_H_
 
 #ifdef __cplusplus
 extern "C" {